#include <cstring>
#include <iostream>
#include <cstdio>
#include <queue>

#define MAX 152

short int lab[MAX][MAX];
short int sol[MAX][MAX];
short int traj[MAX][MAX];
int n;

int CONT=0;

using namespace std;

typedef pair<int,int> pi; // armazena a coordenada... 

typedef struct _No{
	pi coord;
	int depth;
} No;

typedef pair<int, No> pino; // armazena a funcao custo e o no !!

//char moves[4][2] = {0,-1,  // esquerda,
//					0, 1,  // direita,
//					-1,0,  // cima
//					1,0   // baixo
//					};  


//char moves[4][2] = {1,0,
//					-1,0,
//					0,-1,
//					0,1};

char moves[4][2] = {0,-1,
					-1,0,
					1,0,
					0,1};



void printMat(short int mat[][MAX]){
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < n; ++j)
			cout << mat[i][j] << " ";
		cout << endl;
	}
}

bool valido(int x, int y){
	// x e y esta no tabuleiro, se nao é parede e se nao visitei ainda
	if (x<n && x>=0 && y<n && y>=0 && lab[x][y]==1 && sol[x][y]==-1)
		return true;

	return false;
}


bool operator < (const pino& p1, const pino& p2)
{

	//cout << "Opa... entrei na sobrecarga do < .....  " << p1.second.coord.first << " **** " << p2.second.coord.second << endl;
	// this will return true when second person
	// has greater height. Suppose we have p1.height=5
	// and p2.height=5.5 then the object which
	// have max height will be at the top(or
	// max priority)
	return p1.first > p2.first;
}

// esta funcao estima o custo do estado atual (s) até o final desejado (t)
int funcao_custo(No s, pi t){
	// computa a distancia manhattan entre s e t...
	int h = abs (s.coord.first - t.first) + 
            abs (s.coord.second - t.second);
    //int h = abs (abs(s.coord.first - t.first) - abs(s.coord.second - t.second));

 
	return h + s.depth;
	//return h;
}

void printQueue(priority_queue<pino> q){
	pino e;
	while (! q.empty()){
		e = q.top(); q.pop();
		cout << e.first << " * ";
	}
	cout << endl;
}


int Caminho(int x, int y){
	int nx, ny;
	priority_queue<pino> q;
	No no; 
	no.coord = make_pair(x,y);
	no.depth = 0;
	pi final = make_pair(n-1,n-1); // esta é a coordenada final!
	//pi final = make_pair(12,11); // esta é a coordenada final!

	q.push(make_pair(funcao_custo(no,final), no)); //coloca na fila de prioridade. a distancia aqui é zero
	sol[x][y] = funcao_custo(no,final); // marca como visitado
	pino dt;

	while (!q.empty()){ // enquanto houver elementos na fila...
		//printQueue(q);
		dt = q.top(); q.pop(); //retira da fila...
		CONT++;
		traj[dt.second.coord.first][dt.second.coord.second] = CONT;
		//cout << "O custo do no retirado da fila = " << dt.first << endl; 
		no = dt.second;

		// verifica se chegou ao fim...
		if (no.coord.first == final.first && no.coord.second == final.second && lab[no.coord.first][no.coord.second] == 1){
			//cout << "nro de nós retirados da fila =  " << cont << endl;
			return no.depth;
		}

		// para todos os possiveis movimentos do rato
		for (int i = 0; i < 4; ++i){
			nx = no.coord.first+moves[i][0];
			ny = no.coord.second+moves[i][1];
			if (valido(nx,ny)){
				// coloca na fila
				No aux;
				aux.coord = make_pair(nx,ny);
				aux.depth = no.depth+1;
				q.push(make_pair(funcao_custo(aux,final),aux));
				sol[nx][ny] = funcao_custo(aux,final);  // marca a posicao como visitada
			}
		}
	}
	// se tudo falhar... diz que nao tem saida do labirinto...
	return -1;
}

int main(int argc, char const *argv[])
{
	cin >> n;
	// ninguem visitado ainda...
	memset(sol, -1, sizeof sol);
	memset(traj, -1, sizeof traj);

	// lendo o labririnto
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			cin >> lab[i][j];

	int dist;
	if ((dist = Caminho(0,0)) != -1){
		cout << "Achamos uma solucao para este labirinto com distancia =  " << dist << endl;
	} else 
	cout << "Nao tem solucao para este labirinto." << endl;

	cout << "nro de pushes na fila = " << CONT << endl;

	//printMat(lab);
	cout << endl;
	printMat(sol);
	//cout << endl;
	//printMat(traj);

	return 0;
}
